% On utilise ce fichier pour faire l'identification en boucle ferme (entre r et y) en utilisant af-cloe, f-cloe et cloe.

clc;
clear;
close all;

% On charge l'excitation et la sortie, entre lesquelles on veut identifier.
% La commande u est la deuxime colonne de bfreg5m.dat, la sortie y la premire colonne de bfreg5m.dat, l'excitation r la
% troisime colonne.
load bfreg5m.dat;
y=bfreg5m(:,1);
u=bfreg5m(:,2);
r=bfreg5m(:,3);

% On drive l'excitation r:
rd=filter([1 -1],[1 0],r);
rdd=filter([1 -1],[1 0],rd);

% On charge le rgulateur:
load susp5;

% On drive la partie R du rgulateur:
Rd=filter([1 -1],[1 0],R);
Rdd=filter([1 -1],[1 0],Rd);

% On identifie:

disp ('[Baf6,Aaf6]: le modle identifi en utilisant af-cloe');
% un modle d'ordre 6 avec af-cloe:
[Baf6,Aaf6]=afcloe(y,rdd,6,3,3,Rdd,S,S);
disp('Pour continuer, appuyez sur une touche!!!');
pause;

clc;
disp ('[B6,A6]: le modle identifi en utilisant cloe');
% un modle d'ordre 6 avec cloe:
[B6,A6]=cloe(y,rdd,6,3,3,Rdd,S,S);
disp('Pour continuer, appuyez sur une touche!!!');
pause;

clc;
disp ('[Bx6,Ax6]: le modle identifi en utilisant x-cloe');
% un modle d'ordre 6 avec x-cloe:
[Bx6,Ax6]=xcloe(y,rdd,6,3,10,3,Rdd,S,S);
disp('Pour continuer, appuyez sur une touche!!!');
pause;

clc;
disp ('[Bf6,Af6]: le modle identifi en utilisant f-cloe');
[Bf6,Af6]=fcloe(y,rdd,6,3,3,Rdd,S,S,Baf6,Aaf6);
disp('Pour continuer, appuyez sur une touche!!!');
pause;


% *********************************************************************************************
% On introduit dans les modles identifis des drivateurs (1 ou 2, si c'est le cas), afin d'obtenir les modles finals:

Baf6=conv([1 -1],Baf6);
Baf6=conv([1 -1],Baf6);

Bf6=conv([1 -1],Bf6);
Bf6=conv([1 -1],Bf6);

B6=conv([1 -1],B6);
B6=conv([1 -1],B6);

Bx6=conv([1 -1],Bx6);
Bx6=conv([1 -1],Bx6);
% ************************************************************************************************

% Affichage des rsultats:
clc;
disp('Le modle final identifi en boucle ferme en utilisant af-cloe est:');
Baf6
Aaf6
figure(1);
plot(roots(Baf6),'o');
hold on;
plot(roots(Aaf6),'x');
hold off;
zgrid;
title('af-cloe');
axis([-1.1 1.1 -1.1 1.1]);
disp('Pour continuer, appuyez sur une touche!!!');
pause;

clc;
disp('Le modle final identifi en boucle ferme en utilisant cloe est:');
B6
A6
figure(2);
plot(roots(B6),'o');
hold on;
plot(roots(A6),'x');
hold off;
zgrid;
title('cloe');
axis([-1.1 1.1 -1.1 1.1]);
disp('Pour continuer, appuyez sur une touche!!!');
pause;

clc;
disp('Le modle final identifi en boucle ferme en utilisant x-cloe est:');
Bx6
Ax6
figure(3);
plot(roots(Bx6),'o');
hold on;
plot(roots(Ax6),'x');
hold off;
zgrid;
title('x-cloe');
axis([-1.1 1.1 -1.1 1.1]);
disp('Pour continuer, appuyez sur une touche!!!');
pause;

clc;
disp('Le modle final identifi en boucle ferme en utilisant f-cloe est:');
Bf6
Af6
figure(4);
plot(roots(Bf6),'o');
hold on;
plot(roots(Af6),'x');
hold off;
zgrid;
title('f-cloe');
axis([-1.1 1.1 -1.1 1.1]);

% On sauvegarde les modles:
save bfafcl6 Aaf6 Baf6;
save bfcl6 A6 B6;
save bfxcl6 Ax6 Bx6;
save bffcl6 Af6 Bf6;

